// Easy New Notebook
// $Author: Jeffrey J Weimer$
// SVN History: $Revision: 1089 $ on $Date: 2009-07-10 10:31:20 -0500 (Fri, 10 Jul 2009) $

#pragma rtGlobals=1
#pragma IgorVersion=6.10
#pragma version = 1.0

#pragma ModuleName=EasyNewNotebook
#pragma hide=1

// Procedure String Constants
// define the default file folder and its name

Static StrConstant thePackage="EasyNewNotebook"
Static StrConstant thePackageFolder="root:Packages:EasyNewNotebook"
Static StrConstant theProcedureFile = "EasyNewNotebook.ipf"
Static Constant hasHelp = 1

//Static StrConstant kProcFileFolder="EasyNewNotebook"
//Static StrConstant kProcFileName="EasyNewNotebook.ipf"

Static StrConstant KillMeRequest="Do you really want to remove EasyNewNotebook?"

Static Constant kENNHeight = 110
Static Constant kENNWidth = 265

// TEST MODE (comment out for actual use)
//#define TESTME

// Set Menu Hook

Static Function IgorMenuHook(isSel, menuStr, itemStr, itemNo, topWindowName, wt)
	Variable isSel, itemNo, wt
	String menuStr, itemStr, topWindowName

	Variable handled= 0
	string theCmd=""
	switch(isSel)
		case 0:
			break
		case 1:
			if ( (cmpstr(menuStr,"New") == 0) && (cmpstr(itemStr,"Notebook") == 0) )
				EasyNewNotebook#CreateNewNotebook(0)
				handled= 1
			endif
			break
	endswitch
	return handled
End

// Create New Notebook

// initialize the package as needed and put up the panel

Static Function CreateNewNotebook(how)
	variable how
	
	if (WinType("ENN_Panel")!=0)
		DoWindow/F ENN_Panel
		return 0
	endif
	if (DataFolderExists("root:Packages:EasyNewNotebook")==0)
		DFREF cdf=GetDataFolderDFR()
		SetDataFolder root:
		NewDataFolder/O/S Packages
		NewDataFolder/O/S EasyNewNotebook
		string/G title="ENNotebook"
		variable/G left, right, top, bottom
		if(exists("ScreenSizer#Initialize")==6)
			left = 5
			top = 5
			right=30
			bottom = 80
		else
			left = 0
			top = 0
			right = 200
			bottom = 300
		endif
		SetDataFolder cdf
	endif
	
	// include new parameters (as of version 1.0)
	SVAR dfont = root:Packages:EasyNewNotebook:font
	if (!SVAR_exists(dfont))
		DFREF cdf = GetDataFolderDFR()
		SetDataFolder root:Packages:EasyNewNotebook
		string/G font = GetDefaultFont("")
		variable/G fsize = 12
		variable/G kill = 0
		SetDataFolder cdf
	endif
	
	ShowPanel(how)
	return 0
end

// Show Panel
// put up the panel
// 0: new panel
// >0: just draw the buttons with top offset = how!!!!!
// -1: remove buttons added above!!!
// -2: redisplay buttons removed above!!!

Static Function ShowPanel(how)
	variable how

	SVAR title=root:Packages:EasyNewNotebook:title
	NVAR fsize = root:Packages:EasyNewNotebook:fsize
	NVAR left=root:Packages:EasyNewNotebook:left
	NVAR right=root:Packages:EasyNewNotebook:right
	NVAR top=root:Packages:EasyNewNotebook:top
	NVAR bottom=root:Packages:EasyNewNotebook:bottom
	NVAR kill=root:Packages:EasyNewNotebook:kill
	
	// create the panel

	switch(how)
	
		// show certain panel controls
		
		case -2:
			SetVariable enn_left, disable=0
			SetVariable enn_top, disable=0
			SetVariable enn_bottom, disable=0
			SetVariable enn_right, disable=0
			PopupMenu enn_killstate, disable=0
			CheckBox enn_format, disable=0
			ControlInfo enn_format
			CheckBox enn_ruler, disable=!(V_value)
			PopupMenu enn_name, disable=0
			ControlInfo enn_WD
			if (V_flag!=0)
				PopupMenu enn_WD, disable=0
			endif
			title = "ENNotebook"
			break
	
		// remove certain panel controls
		
		case -1:
			SetVariable enn_left, disable=1
			SetVariable enn_top, disable=1
			SetVariable enn_bottom, disable=1
			SetVariable enn_right, disable=1
			PopupMenu enn_killstate, disable=1
			CheckBox enn_format, disable=1
			CheckBox enn_ruler, disable=1
			PopupMenu enn_name, disable=1
			ControlInfo enn_WD
			if (V_flag!=0)
				PopupMenu enn_WD, disable=1
			endif
			break
			
		// create the panel
		
		case 0:
			title = "ENNotebook"
			string pname = "ENN Panel"

// use ScreenSizer if it exists
// make sure sizes are within bounds
			
			if(exists("ScreenSizer#Initialize")==6)
				left = left*(left<100)
				top = top*(top<100)
				right = right*(right<100)
				right += 30*(right==0)
				bottom = bottom*(bottom<100)
				bottom += 50*(bottom==0)
				pname += " +SS"
				string theCmd =""
				sprintf theCmd "ScreenSizer#MakePanel(30,15,%d,%d,\"%s\",other=\"/K=1/N=ENN_Panel\")", kENNWidth, kENNHeight,pname
				Execute/Q/Z theCmd
			else
				NewPanel/K=1/N=ENN_Panel/W=(20,20,20+kENNWidth,20+kENNHeight) as pname
			endif

			killstrings/Z root:S_name
			
// in test mode, allow panel edits and do not use panel hook

#ifndef TESTME
			ModifyPanel noEdit=1,fixedSize=1
			SetWindow ENN_Panel,hook(ENN)=EasyNewNotebook#closeme
#else
			pname += " TEST"
#endif

// use WindowDesktops if it exists

			if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
				pname += " +WD"
			endif

			// name the panel
	
			DoWindow/T ENN_Panel,pname

			// do it

			Button enn_doit,pos={211,65},size={50,20},proc=EasyNewNotebook#DoIt,title="Do It"

			// NOTEBOOK CONTROLS
			
			// title and name
			
			SetVariable enn_title,value=title,pos={7,7+how},size={210,16},title="Title"
			
			// help button
			
			Button enn_gethelp,pos={225,5+how},size={15,20},proc=EasyNewNotebook#HelporRemove,title="?"
			
			// removeme button
			
			Button enn_removeme,pos={245,5+how},size={15,20},proc=EasyNewNotebook#HelporRemove,title="X"

		// put certain panel controls
		
		default:

// use WindowDesktops if it exists and a current desktop has been set

			if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
				variable/G tmpcDD
				Execute/Q/Z "ACL_WindowDesktops#GetDisplayedDesktop(globalOutputVarPathStr=\"root:tmpcDD\")"
				NVAR cDD = root:tmpcDD
				if (numtype(cDD)==2)
					PopupMenu enn_WD title="",value="-;D;1;2;3;4;", pos={165,65+how}, mode=1
				else
					PopupMenu enn_WD title="",value="-;D;1;2;3;4;", pos={165,65+how}, mode=(cDD+2)
				endif
				killvariables root:tmpcDD
			endif

			PopupMenu enn_name,pos={7,25+how},size={116,21},title="Name"
			PopupMenu enn_name,mode=1,popvalue="From Title",value= #"\"From Title;Time Stamp;\""
		
			// format or not
			
			CheckBox enn_format,pos={145,25+how},size={65,14},title="Format",value= 1,proc=EasyNewNotebook#SetFormat
			CheckBox enn_ruler,pos={210,25+how},size={43,14},title="Ruler",value= 0
		
			// kill state
			
			string kstr =StringFromList(kill,"Normal;Silent;NO KILL;Hide Only;")
			PopupMenu enn_killstate,pos={159,43+how},size={88,21},title="Kill",proc=EasyNewNotebook#SetKillState
			PopupMenu enn_killstate,mode=(kill+1),popvalue=kstr,value="Normal;Silent;NO KILL;Hide Only;"
		
			// sizes
		
			SetVariable enn_top,pos={5,48+how},size={70,16},value=top
			SetVariable enn_left,pos={5,66+how},size={70,16},value=left
			SetVariable enn_right,pos={84,48+how},size={70,16},value=right
			SetVariable enn_bottom,pos={84,66+how},size={70,16},value=bottom

			// use screensizer if it exists
			
			if(exists("ScreenSizer#Initialize")==6)
				SetVariable enn_left, title=">%", limits={5,100,5}
				SetVariable enn_top, title="V%", limits={5,100,5}
				SetVariable enn_bottom, title="V%", limits={5,100,5}
				SetVariable enn_right, title=">%", limits={5,100,5}
			else
				SetVariable enn_left, title=">",limits={10,600,10}
				SetVariable enn_top, title="V",limits={10,600,10}
				SetVariable enn_right, title=">",limits={10,600,10}
				SetVariable enn_bottom, title="V",limits={10,600,10}
			endif
			
			// font settings
			
			variable wp = WhichListItem(num2str(fsize),"9;10;12;14;")+1
			PopupMenu enn_fontsize,title="Font ",pos={5,88+how},mode=wp,value="9;10;12;14;",popvalue=num2str(fsize),proc=EasyNewNotebook#SetFontSize
			PopupMenu enn_fontlist,title="pt  ",pos={83,88+how},mode=1,value=#"EasyNewNotebook#TheShortFontList()",proc=EasyNewNotebook#SetFont
			break
	endswitch
	DoWindow/F ENN_Panel
	SetVariable enn_title, activate
	return 0
End

Static Function SetPosition(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	NVAR left=root:Packages:EasyNewNotebook:left
	NVAR right=root:Packages:EasyNewNotebook:right
	NVAR top=root:Packages:EasyNewNotebook:top
	NVAR bottom=root:Packages:EasyNewNotebook:bottom

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			strswitch(sva.ctrlName)
				case "enn_top":
					top = sva.dval
					break
				case "enn_left":
					left = sva.dval
					break
				case "enn_right":
					right = sva.dval
					break
				case "enn_bottom":
					bottom = sva.dval
					break
			endswitch
			break
	endswitch

	return 0
End

Static Function SetKillState(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	NVAR kill = root:Packages:EasyNewNotebook:kill

	switch( pa.eventCode )
		case 2: // mouse up
			kill = pa.popNum-1
			break
	endswitch

	return 0
End

Static Function SetFontSize(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	NVAR fsize = root:Packages:EasyNewNotebook:fsize

	switch( pa.eventCode )
		case 2: // mouse up
			fsize = str2num(pa.popStr)
			break
	endswitch

	return 0
End

Static Function SetFont(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	SVAR dfont = root:Packages:EasyNewNotebook:font

	switch( pa.eventCode )
		case 2: // mouse up
			if (pa.popNum==1)
				dfont = GetDefaultFont("")
			else
				dfont = pa.popStr
			endif
			break
	endswitch

	return 0
End

Static Function/S TheShortFontList()

	SVAR dfont = root:Packages:EasyNewNotebook:font
	
	string flist=FontList(";")
	string rlist = "Default (" + dfont + ");"
	rlist += ListMatch(flist,"Arial")
	rlist += ListMatch(flist,"Helvetica")
	rlist += ListMatch(flist,"Geneva")
	rlist += ListMatch(flist,"Times")
	rlist += ListMatch(flist,"Times New Roman")
	rlist = RemoveFromList(dfont,rlist)
	
	return rlist
End

// Close Me
// close panel

Static Function CloseMe(ws)
	STRUCT WMWinHookStruct &ws

	SVAR title=root:Packages:EasyNewNotebook:title
	STRUCT WMButtonAction ba
	
	switch(ws.eventCode)
		case 1:
			if (cmpstr(title,"SetMe!")==0)
				title=""
				KillWindow ENN_Panel
				break
			endif
			beep
			title="SetMe!"
			DoWindow/F ENN_Panel
			SetVariable enn_title, activate
			beep
			break
		case 11:
			if (ws.keyCode==13)
				ba.win=ws.winname
				ba.eventCode=2
				ba.ctrlName="DoIt"
				ba.userData=""
				DoIt(ba)
			endif
			break
		default:
			break
	endswitch
	return 0
end

// Get Help

Static Function HelporRemove(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2:
			strswitch(ba.ctrlName)
				case "enn_GetHelp":
					EasyNewNotebook#Help()
					break
				case "enn_RemoveMe":
					EasyNewNotebook#RemoveMe()
					break
			endswitch
			break
	endswitch
	
	return 0
end

// DoIt
// create new notebook

Static Function DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	SVAR title=root:Packages:EasyNewNotebook:title
	SVAR dfont = root:Packages:EasyNewNotebook:font
	NVAR fsize = root:Packages:EasyNewNotebook:fsize
	NVAR left=root:Packages:EasyNewNotebook:left
	NVAR right=root:Packages:EasyNewNotebook:right
	NVAR top=root:Packages:EasyNewNotebook:top
	NVAR bottom=root:Packages:EasyNewNotebook:bottom

	variable format, kill, ruler, wd = -1
	string name=""

	switch( ba.eventCode )
		case 2:
			ControlInfo enn_format
			format = V_value
			ControlInfo enn_killstate
			kill = V_value-1
			ControlInfo enn_ruler
			ruler = V_value
			if (strlen(title)==0)
				if (strlen(ba.userData)==0)
					title="ENNotebook"
				else
					title=ba.userData
				endif
			endif
			ControlInfo enn_name
			if (V_value==1)
				name=CleanUpName(title,0)
			else
				name="ENNotebook"+CleanUpName(time(),0)
			endif
			sprintf name, "%s%d", name, ItemsInList(WinList((name+"*"),";","WIN:16"))
			ControlInfo enn_WD
			if (V_flag!=0)
				wd = V_value-2
			endif
			if (WinType("ENN_Panel"))
				KillWindow ENN_Panel
			endif
			if (strlen(title)==0)
				NewNotebook/K=(kill)/F=(format)
			else
				NewNotebook/K=(kill)/F=(format)/N=$name as title
			endif
			if (format)
				Notebook $name showRuler=(ruler)			
				Notebook $name ruler=Normal, rulerDefaults={dfont,fsize,0,(0,0,0)}
			endif
			
			string theCmd = ""
			
// use ScreenSizer if it exists

			if(exists("ScreenSizer#Initialize")==6)
				sprintf theCmd "ScreenSizer#MoveFrontWindow(%d,%d,%d,%d)", left, top, right, bottom
				Execute/Q/Z theCmd
			else
				MoveWindow left, top, right, bottom
			endif

// use Window Desktops if it exists

			if(exists("ACL_WindowDesktops#Initialize_pnlDesktopControl")==6)
				if (wd>=0)
					variable/G tmpcDD
					Execute/Q/Z "ACL_WindowDesktops#GetDisplayedDesktop(globalOutputVarPathStr=\"root:tmpcDD\")"
					NVAR cDD = root:tmpcDD
					if (numtype(cDD)==2)
						sprintf theCmd "ACL_WindowDesktops#Initialize_pnlDesktopControl()"
						Execute/Q/Z theCmd
					endif
					killvariables root:tmpcDD
					sprintf theCmd "ACL_WindowDesktops#SetWindowDesktop(\"%s\",%d)", name, wd
					Execute/Q/Z theCmd
				endif
			endif
			break
	endswitch
	ba.userData=name
	
	return 0
End

// SetFormat
// toggle on/off the ruler CheckBox enn_depending on format checkbox

Static Function SetFormat(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			CheckBox enn_ruler, disable=!cba.checked
			break
	endswitch

	return 0
End

// Help Static Function

Static Function Help()

	if (!hasHelp)
		DoAlert 0, "NO HELP FOR THIS PACKAGE!"
		return 0
	endif

	if (strlen(thePackage)!=0)
		DisplayHelpTopic thePackage
	else
		DoAlert 0, "NO PACKAGE NAME FOR HELP!"
		return -1
	endif
	return 0
end

// Remove Me

Static Function RemoveMe([quiet])
	variable quiet
	
	if (ParamIsDefault(quiet) || (quiet == 0))
		DoAlert 1, KillMeRequest	
		if (V_flag == 2)
			return 0
		endif
	endif
	
	if (strlen(thePackageFolder)!=0)
		KillDataFolder/Z $thePackageFolder
	endif
	
	string theCmd
	if (strlen(thePackage)!=0)
		sprintf theCmd "DELETEINCLUDE %s" thePackage
		Execute/P/Z/Q theCmd
	endif
	if (strlen(theProcedureFile)!=0)
		sprintf theCmd "CloseProc/NAME=\"%s\"" theProcedureFile	
		Execute/P/Q theCmd
	endif
	
	return 0
end